/*
 * CCAF.c
 *
 * Code generation for function 'CCAF'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "CCAF.h"
#include "gjbf_emxutil.h"
#include "gjbf_data.h"
#include "blas.h"

/* Variable Definitions */
static emlrtRTEInfo i_emlrtRTEI = { 1, 15, "CCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\CCAF.m" };

static emlrtRTEInfo j_emlrtRTEI = { 8, 13, "CCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\CCAF.m" };

static emlrtECInfo g_emlrtECI = { 2, 9, 26, "CCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\CCAF.m" };

static emlrtECInfo h_emlrtECI = { 2, 10, 26, "CCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\CCAF.m" };

/* Function Definitions */
void CCAF(const emlrtStack *sp, const real_T phi[320], const real_T psi[320],
          real_T order, real_T w[320], const boolean_T amcInds[16])
{
  emxArray_real_T *amcIndMat;
  int32_T i;
  int32_T loop_ub;
  int32_T iv60[2];
  int32_T i43;
  int32_T b_amcIndMat[2];
  boolean_T uBoundInds[320];
  boolean_T bv21[320];
  int32_T iv61[2];
  int32_T c_amcIndMat[2];
  boolean_T lBoundInds[320];
  boolean_T bv22[320];
  emlrtHeapReferenceStackEnterFcnR2012b(sp);
  emxInit_real_T(sp, &amcIndMat, 2, &j_emlrtRTEI, true);
  covrtLogFcn(&emlrtCoverageInstance, 7U, 0);
  covrtLogCond(&emlrtCoverageInstance, 7U, 0U, 0, false);
  covrtLogMcdc(&emlrtCoverageInstance, 7U, 0U, 0, true);
  covrtLogIf(&emlrtCoverageInstance, 7U, 0U, 0, true);
  covrtLogBasicBlock(&emlrtCoverageInstance, 7U, 0);

  /*  Expand bound vectors and run weight comparison */
  /*  Include AMC thresholding if specified */
  covrtLogCond(&emlrtCoverageInstance, 7U, 0U, 1, false);
  covrtLogMcdc(&emlrtCoverageInstance, 7U, 0U, 1, true);
  covrtLogIf(&emlrtCoverageInstance, 7U, 0U, 1, true);
  covrtLogBasicBlock(&emlrtCoverageInstance, 7U, 1);
  i = amcIndMat->size[0] * amcIndMat->size[1];
  amcIndMat->size[0] = (int32_T)order;
  amcIndMat->size[1] = 16;
  emxEnsureCapacity(sp, (emxArray__common *)amcIndMat, i, (int32_T)sizeof(real_T),
                    &i_emlrtRTEI);
  loop_ub = (int32_T)order;
  for (i = 0; i < loop_ub; i++) {
    for (i43 = 0; i43 < 16; i43++) {
      amcIndMat->data[i + amcIndMat->size[0] * i43] = amcInds[i43];
    }
  }

  for (i = 0; i < 2; i++) {
    iv60[i] = 20 + -4 * i;
  }

  for (i = 0; i < 2; i++) {
    b_amcIndMat[i] = amcIndMat->size[i];
  }

  if ((iv60[0] != b_amcIndMat[0]) || (iv60[1] != b_amcIndMat[1])) {
    emlrtSizeEqCheckNDR2012b(&iv60[0], &b_amcIndMat[0], &g_emlrtECI, sp);
  }

  for (i = 0; i < 320; i++) {
    uBoundInds[i] = (w[i] > phi[i]);
  }

  for (i = 0; i < 320; i++) {
    bv21[i] = (amcIndMat->data[i] != 0.0);
  }

  for (i = 0; i < 2; i++) {
    iv61[i] = 20 + -4 * i;
  }

  for (i = 0; i < 2; i++) {
    c_amcIndMat[i] = amcIndMat->size[i];
  }

  if ((iv61[0] != c_amcIndMat[0]) || (iv61[1] != c_amcIndMat[1])) {
    emlrtSizeEqCheckNDR2012b(&iv61[0], &c_amcIndMat[0], &h_emlrtECI, sp);
  }

  for (i = 0; i < 320; i++) {
    lBoundInds[i] = (w[i] < psi[i]);
  }

  for (i = 0; i < 320; i++) {
    bv22[i] = (amcIndMat->data[i] != 0.0);
  }

  emxFree_real_T(&amcIndMat);
  covrtLogBasicBlock(&emlrtCoverageInstance, 7U, 2);

  /*  Apply bounds to tap matrix */
  for (i = 0; i < 320; i++) {
    if (uBoundInds[i] && bv21[i]) {
      w[i] = phi[i];
    }
  }

  for (i = 0; i < 320; i++) {
    if (lBoundInds[i] && bv22[i]) {
      w[i] = psi[i];
    }
  }

  covrtLogBasicBlock(&emlrtCoverageInstance, 7U, 3);
  emlrtHeapReferenceStackLeaveFcnR2012b(sp);
}

/* End of code generation (CCAF.c) */
