/*
 * isfinite.c
 *
 * Code generation for function 'isfinite'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "isfinite.h"
#include "blas.h"

/* Function Definitions */
void b_isfinite(const real_T x[14112], boolean_T b[14112])
{
  int32_T i3;
  for (i3 = 0; i3 < 14112; i3++) {
    b[i3] = ((!muDoubleScalarIsInf(x[i3])) && (!muDoubleScalarIsNaN(x[i3])));
  }
}

boolean_T c_isfinite(real_T x)
{
  return (!muDoubleScalarIsInf(x)) && (!muDoubleScalarIsNaN(x));
}

void d_isfinite(const real_T x[3], boolean_T b[3])
{
  int32_T i;
  for (i = 0; i < 3; i++) {
    b[i] = ((!muDoubleScalarIsInf(x[i])) && (!muDoubleScalarIsNaN(x[i])));
  }
}

void e_isfinite(const real_T x[48], boolean_T b[48])
{
  int32_T i7;
  for (i7 = 0; i7 < 48; i7++) {
    b[i7] = ((!muDoubleScalarIsInf(x[i7])) && (!muDoubleScalarIsNaN(x[i7])));
  }
}

void f_isfinite(const real_T x[320], boolean_T b[320])
{
  int32_T i15;
  for (i15 = 0; i15 < 320; i15++) {
    b[i15] = ((!muDoubleScalarIsInf(x[i15])) && (!muDoubleScalarIsNaN(x[i15])));
  }
}

void g_isfinite(const emxArray_real_T *x, boolean_T b_data[], int32_T b_size[2])
{
  int32_T loop_ub;
  int32_T i19;
  boolean_T tmp_data[14112];
  b_size[0] = x->size[0];
  loop_ub = x->size[0] * x->size[1];
  for (i19 = 0; i19 < loop_ub; i19++) {
    b_data[i19] = muDoubleScalarIsInf(x->data[i19]);
  }

  loop_ub = x->size[0] * x->size[1];
  for (i19 = 0; i19 < loop_ub; i19++) {
    tmp_data[i19] = muDoubleScalarIsNaN(x->data[i19]);
  }

  b_size[1] = 16;
  loop_ub = b_size[0] << 4;
  for (i19 = 0; i19 < loop_ub; i19++) {
    b_data[i19] = ((!b_data[i19]) && (!tmp_data[i19]));
  }
}

void h_isfinite(const real_T x_data[], const int32_T x_size[1], boolean_T
                b_data[], int32_T b_size[1])
{
  int32_T loop_ub;
  int32_T i21;
  boolean_T tmp_data[1764];
  b_size[0] = x_size[0];
  loop_ub = x_size[0];
  for (i21 = 0; i21 < loop_ub; i21++) {
    b_data[i21] = muDoubleScalarIsInf(x_data[i21]);
  }

  loop_ub = x_size[0];
  for (i21 = 0; i21 < loop_ub; i21++) {
    tmp_data[i21] = muDoubleScalarIsNaN(x_data[i21]);
  }

  loop_ub = x_size[0];
  for (i21 = 0; i21 < loop_ub; i21++) {
    b_data[i21] = ((!b_data[i21]) && (!tmp_data[i21]));
  }
}

/* End of code generation (isfinite.c) */
