/*
 * sqrt.c
 *
 * Code generation for function 'sqrt'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "sqrt.h"
#include "error1.h"
#include "gjbf_data.h"
#include "blas.h"

/* Function Definitions */
void b_sqrt(const emlrtStack *sp, real_T x[16])
{
  boolean_T p;
  int32_T k;
  emlrtStack st;
  st.prev = sp;
  st.tls = sp->tls;
  p = false;
  for (k = 0; k < 16; k++) {
    if (p || (x[k] < 0.0)) {
      p = true;
    } else {
      p = false;
    }
  }

  if (p) {
    st.site = &ac_emlrtRSI;
    w_error(&st);
  }

  for (k = 0; k < 16; k++) {
    x[k] = muDoubleScalarSqrt(x[k]);
  }
}

/* End of code generation (sqrt.c) */
