/*
 * targmc.c
 *
 * Code generation for function 'targmc'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "targmc.h"
#include "mclms.h"
#include "gjbf_emxutil.h"
#include "gjbf_mexutil.h"
#include "gjbf_data.h"
#include "blas.h"

/* Variable Definitions */
static emlrtRSInfo ne_emlrtRSI = { 14, "targmc",
  "E:\\micro array project\\Microphone Array\\beamform test\\targmc.m" };

static emlrtRSInfo oe_emlrtRSI = { 11, "targmc",
  "E:\\micro array project\\Microphone Array\\beamform test\\targmc.m" };

static emlrtRTEInfo e_emlrtRTEI = { 1, 23, "targmc",
  "E:\\micro array project\\Microphone Array\\beamform test\\targmc.m" };

static emlrtBCInfo l_emlrtBCI = { -1, -1, 14, 16, "y", "targmc",
  "E:\\micro array project\\Microphone Array\\beamform test\\targmc.m", 0 };

static emlrtBCInfo m_emlrtBCI = { 1, 882, 7, 18, "z", "targmc",
  "E:\\micro array project\\Microphone Array\\beamform test\\targmc.m", 0 };

static emlrtBCInfo n_emlrtBCI = { 1, 882, 5, 47, "z", "targmc",
  "E:\\micro array project\\Microphone Array\\beamform test\\targmc.m", 0 };

static emlrtBCInfo o_emlrtBCI = { -1, -1, 5, 23, "zPrev", "targmc",
  "E:\\micro array project\\Microphone Array\\beamform test\\targmc.m", 0 };

static emlrtBCInfo p_emlrtBCI = { -1, -1, 11, 8, "b", "targmc",
  "E:\\micro array project\\Microphone Array\\beamform test\\targmc.m", 0 };

static emlrtBCInfo q_emlrtBCI = { -1, -1, 11, 1, "y", "targmc",
  "E:\\micro array project\\Microphone Array\\beamform test\\targmc.m", 0 };

/* Function Definitions */
void targmc(const emlrtStack *sp, const emxArray_real_T *zPrev, const real_T z
            [14112], const real_T b_data[], const int32_T b_size[1], real_T n,
            real_T order, const real_T w[320], real_T y_data[], int32_T y_size[1],
            emxArray_real_T *zWin)
{
  real_T alpha1;
  int32_T j;
  int32_T i44;
  int32_T i45;
  int32_T loop_ub;
  int32_T i46;
  real_T a[320];
  real_T beta1;
  char_T TRANSB;
  char_T TRANSA;
  real_T y[256];
  ptrdiff_t m_t;
  ptrdiff_t n_t;
  ptrdiff_t k_t;
  ptrdiff_t lda_t;
  ptrdiff_t ldb_t;
  ptrdiff_t ldc_t;
  real_T d[16];
  const mxArray *b_y;
  char_T u[19];
  static const char_T varargin_1[19] = { 'O', 'u', 't', 'p', 'u', 't', ' ', 'h',
    'a', 's', ' ', 'b', 'l', 'o', 'w', 'n', ' ', 'u', 'p' };

  const mxArray *m29;
  static const int32_T iv62[2] = { 1, 19 };

  emlrtStack st;
  emlrtStack b_st;
  st.prev = sp;
  st.tls = sp->tls;
  b_st.prev = &st;
  b_st.tls = st.tls;
  covrtLogFcn(&emlrtCoverageInstance, 9U, 0);

  /*  Select the data window for this iteration */
  if (covrtLogIf(&emlrtCoverageInstance, 9U, 0U, 0, n <= order)) {
    covrtLogBasicBlock(&emlrtCoverageInstance, 9U, 0);

    /*  feed in supplied past values ahead of z */
    alpha1 = (((real_T)zPrev->size[0] - order) + n) + 1.0;
    if (alpha1 > zPrev->size[0]) {
      j = 0;
      i45 = 0;
    } else {
      j = zPrev->size[0];
      i44 = (int32_T)alpha1;
      if (!((i44 >= 1) && (i44 <= j))) {
        emlrtDynamicBoundsCheckR2012b(i44, 1, j, &o_emlrtBCI, sp);
      }

      j = i44 - 1;
      i44 = zPrev->size[0];
      i45 = zPrev->size[0];
      if (!((i45 >= 1) && (i45 <= i44))) {
        emlrtDynamicBoundsCheckR2012b(i45, 1, i44, &o_emlrtBCI, sp);
      }
    }

    i44 = (int32_T)n;
    if (!((i44 >= 1) && (i44 <= 882))) {
      emlrtDynamicBoundsCheckR2012b(i44, 1, 882, &n_emlrtBCI, sp);
    }

    i44 = zWin->size[0] * zWin->size[1];
    zWin->size[0] = (i45 - j) + (int32_T)n;
    zWin->size[1] = 16;
    emxEnsureCapacity(sp, (emxArray__common *)zWin, i44, (int32_T)sizeof(real_T),
                      &e_emlrtRTEI);
    for (i44 = 0; i44 < 16; i44++) {
      loop_ub = i45 - j;
      for (i46 = 0; i46 < loop_ub; i46++) {
        zWin->data[i46 + zWin->size[0] * i44] = zPrev->data[(j + i46) +
          zPrev->size[0] * i44];
      }
    }

    for (i44 = 0; i44 < 16; i44++) {
      loop_ub = (int32_T)n;
      for (i46 = 0; i46 < loop_ub; i46++) {
        zWin->data[((i46 + i45) - j) + zWin->size[0] * i44] = z[i46 + 882 * i44];
      }
    }
  } else {
    covrtLogBasicBlock(&emlrtCoverageInstance, 9U, 1);

    /*  need only data from given z */
    alpha1 = (n - order) + 1.0;
    if (alpha1 > n) {
      j = 0;
      i44 = 0;
    } else {
      j = (int32_T)alpha1;
      if (!((j >= 1) && (j <= 882))) {
        emlrtDynamicBoundsCheckR2012b(j, 1, 882, &m_emlrtBCI, sp);
      }

      j--;
      i44 = (int32_T)n;
      if (!((i44 >= 1) && (i44 <= 882))) {
        emlrtDynamicBoundsCheckR2012b(i44, 1, 882, &m_emlrtBCI, sp);
      }
    }

    i45 = zWin->size[0] * zWin->size[1];
    zWin->size[0] = i44 - j;
    zWin->size[1] = 16;
    emxEnsureCapacity(sp, (emxArray__common *)zWin, i45, (int32_T)sizeof(real_T),
                      &e_emlrtRTEI);
    for (i45 = 0; i45 < 16; i45++) {
      loop_ub = i44 - j;
      for (i46 = 0; i46 < loop_ub; i46++) {
        zWin->data[i46 + zWin->size[0] * i45] = z[(j + i46) + 882 * i45];
      }
    }
  }

  covrtLogBasicBlock(&emlrtCoverageInstance, 9U, 2);

  /* initial w, and calculate output y  */
  st.site = &oe_emlrtRSI;
  for (j = 0; j < 20; j++) {
    for (i44 = 0; i44 < 16; i44++) {
      a[i44 + (j << 4)] = w[j + 20 * i44];
    }
  }

  b_st.site = &bd_emlrtRSI;
  if (!(20 == zWin->size[0])) {
    emlrtErrorWithMessageIdR2012b(&b_st, &y_emlrtRTEI, "Coder:MATLAB:innerdim",
      0);
  }

  b_st.site = &ad_emlrtRSI;
  alpha1 = 1.0;
  beta1 = 0.0;
  TRANSB = 'N';
  TRANSA = 'N';
  memset(&y[0], 0, sizeof(real_T) << 8);
  m_t = (ptrdiff_t)16;
  n_t = (ptrdiff_t)16;
  k_t = (ptrdiff_t)20;
  lda_t = (ptrdiff_t)16;
  ldb_t = (ptrdiff_t)20;
  ldc_t = (ptrdiff_t)16;
  dgemm(&TRANSA, &TRANSB, &m_t, &n_t, &k_t, &alpha1, &a[0], &lda_t, &zWin->data
        [0], &ldb_t, &beta1, &y[0], &ldc_t);
  for (j = 0; j < 16; j++) {
    d[j] = y[j * 17];
  }

  alpha1 = d[0];
  for (j = 0; j < 15; j++) {
    alpha1 += d[j + 1];
  }

  j = (int32_T)n;
  if (!((j >= 1) && (j <= b_size[0]))) {
    emlrtDynamicBoundsCheckR2012b(j, 1, b_size[0], &p_emlrtBCI, sp);
  }

  i44 = y_size[0];
  i45 = (int32_T)n;
  if (!((i45 >= 1) && (i45 <= i44))) {
    emlrtDynamicBoundsCheckR2012b(i45, 1, i44, &q_emlrtBCI, sp);
  }

  y_data[i45 - 1] = b_data[j - 1] - alpha1;

  /* check y inf or not */
  j = y_size[0];
  i44 = (int32_T)n;
  if (!((i44 >= 1) && (i44 <= j))) {
    emlrtDynamicBoundsCheckR2012b(i44, 1, j, &l_emlrtBCI, sp);
  }

  if (covrtLogIf(&emlrtCoverageInstance, 9U, 0U, 1, covrtLogMcdc
                 (&emlrtCoverageInstance, 9U, 0U, 0, !covrtLogCond
                  (&emlrtCoverageInstance, 9U, 0U, 0, (!muDoubleScalarIsInf
          (y_data[(int32_T)n - 1])) && (!muDoubleScalarIsNaN(y_data[(int32_T)n -
           1])))))) {
    st.site = &ne_emlrtRSI;
    for (j = 0; j < 19; j++) {
      u[j] = varargin_1[j];
    }

    b_y = NULL;
    m29 = emlrtCreateCharArray(2, iv62);
    emlrtInitCharArrayR2013a(&st, 19, m29, &u[0]);
    emlrtAssign(&b_y, m29);
    b_st.site = &af_emlrtRSI;
    ab_error(&b_st, b_y, &emlrtMCI);
  }

  covrtLogBasicBlock(&emlrtCoverageInstance, 9U, 3);
}

/* End of code generation (targmc.c) */
