/*
 * NCAF.c
 *
 * Code generation for function 'NCAF'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "NCAF.h"
#include "gjbf_emxutil.h"
#include "error1.h"
#include "eml_int_forloop_overflow_check.h"
#include "gjbf_data.h"
#include "blas.h"

/* Variable Definitions */
static emlrtRSInfo se_emlrtRSI = { 5, "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m" };

static emlrtRSInfo te_emlrtRSI = { 12, "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m" };

static emlrtRSInfo ue_emlrtRSI = { 25, "indexShapeCheck",
  "C:\\Program Files\\MATLAB\\R2016a\\toolbox\\eml\\eml\\+coder\\+internal\\indexShapeCheck.m"
};

static emlrtRSInfo ve_emlrtRSI = { 80, "indexShapeCheck",
  "C:\\Program Files\\MATLAB\\R2016a\\toolbox\\eml\\eml\\+coder\\+internal\\indexShapeCheck.m"
};

static emlrtRSInfo we_emlrtRSI = { 23, "indexShapeCheck",
  "C:\\Program Files\\MATLAB\\R2016a\\toolbox\\eml\\eml\\+coder\\+internal\\indexShapeCheck.m"
};

static emlrtRSInfo xe_emlrtRSI = { 15, "sqrt",
  "C:\\Program Files\\MATLAB\\R2016a\\toolbox\\eml\\lib\\matlab\\elfun\\sqrt.m"
};

static emlrtRSInfo ye_emlrtRSI = { 24, "applyScalarFunctionInPlace",
  "C:\\Program Files\\MATLAB\\R2016a\\toolbox\\eml\\eml\\+coder\\+internal\\applyScalarFunctionInPlace.m"
};

static emlrtRTEInfo m_emlrtRTEI = { 1, 15, "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m" };

static emlrtRTEInfo n_emlrtRTEI = { 6, 9, "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m" };

static emlrtRTEInfo o_emlrtRTEI = { 9, 13, "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m" };

static emlrtBCInfo t_emlrtBCI = { 1, 882, 9, 49, "mcAdapt", "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m", 0 };

static emlrtECInfo k_emlrtECI = { 2, 10, 20, "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m" };

static emlrtECInfo l_emlrtECI = { -1, 12, 13, "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m" };

static emlrtECInfo m_emlrtECI = { -1, 12, 3, "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m" };

static emlrtBCInfo u_emlrtBCI = { 1, 320, 12, 13, "w", "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m", 0 };

static emlrtBCInfo v_emlrtBCI = { -1, -1, 12, 32, "OmegaMat", "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m", 0 };

static emlrtBCInfo w_emlrtBCI = { 1, 320, 12, 3, "w", "NCAF",
  "E:\\micro array project\\Microphone Array\\beamform test\\NCAF.m", 0 };

/* Function Definitions */
void NCAF(const emlrtStack *sp, real_T K, real_T w[320], real_T order, real_T n,
          const real_T mcAdapt[14112])
{
  real_T y[320];
  int32_T k;
  real_T Omega[16];
  int32_T i;
  emxArray_real_T *OmegaMat;
  int32_T xoffset;
  real_T s;
  int32_T i48;
  emxArray_real_T *amcIndMat;
  emxArray_boolean_T *r3;
  int32_T iv66[2];
  int32_T b_amcIndMat[2];
  emxArray_boolean_T *r4;
  int32_T indexSize[2];
  boolean_T nonSingletonDimFound;
  emxArray_int32_T *r5;
  emxArray_real_T *x;
  emxArray_real_T *r6;
  emxArray_real_T *r7;
  emlrtStack st;
  emlrtStack b_st;
  emlrtStack c_st;
  emlrtStack d_st;
  st.prev = sp;
  st.tls = sp->tls;
  b_st.prev = &st;
  b_st.tls = st.tls;
  c_st.prev = &b_st;
  c_st.tls = b_st.tls;
  d_st.prev = &c_st;
  d_st.tls = c_st.tls;
  emlrtHeapReferenceStackEnterFcnR2012b(sp);
  covrtLogFcn(&emlrtCoverageInstance, 11U, 0);
  covrtLogCond(&emlrtCoverageInstance, 11U, 0U, 0, false);
  covrtLogMcdc(&emlrtCoverageInstance, 11U, 0U, 0, true);
  covrtLogIf(&emlrtCoverageInstance, 11U, 0U, 0, true);
  covrtLogBasicBlock(&emlrtCoverageInstance, 11U, 0);

  /*  Finding norm without Matlab's function lets us avoid for */
  st.site = &se_emlrtRSI;
  b_st.site = &xb_emlrtRSI;
  for (k = 0; k < 320; k++) {
    y[k] = w[k] * w[k];
  }

  for (i = 0; i < 16; i++) {
    xoffset = i * 20;
    s = y[xoffset];
    for (k = 0; k < 19; k++) {
      s += y[(xoffset + k) + 1];
    }

    Omega[i] = s;
  }

  emxInit_real_T(sp, &OmegaMat, 2, &n_emlrtRTEI, true);

  /*  Find norm of all columns */
  i48 = OmegaMat->size[0] * OmegaMat->size[1];
  OmegaMat->size[0] = (int32_T)order;
  OmegaMat->size[1] = 16;
  emxEnsureCapacity(sp, (emxArray__common *)OmegaMat, i48, (int32_T)sizeof
                    (real_T), &m_emlrtRTEI);
  k = (int32_T)order;
  for (i48 = 0; i48 < k; i48++) {
    for (i = 0; i < 16; i++) {
      OmegaMat->data[i48 + OmegaMat->size[0] * i] = Omega[i];
    }
  }

  emxInit_real_T(sp, &amcIndMat, 2, &o_emlrtRTEI, true);

  /*  Expand to a norm matrix */
  /*  save comparison so it doesnt repeat */
  covrtLogCond(&emlrtCoverageInstance, 11U, 0U, 1, false);
  covrtLogMcdc(&emlrtCoverageInstance, 11U, 0U, 1, true);
  covrtLogIf(&emlrtCoverageInstance, 11U, 0U, 1, true);
  covrtLogBasicBlock(&emlrtCoverageInstance, 11U, 1);

  /*  apply AMC SNR threshold if specified */
  i48 = (int32_T)n;
  if (!((i48 >= 1) && (i48 <= 882))) {
    emlrtDynamicBoundsCheckR2012b(i48, 1, 882, &t_emlrtBCI, sp);
  }

  i48 = amcIndMat->size[0] * amcIndMat->size[1];
  amcIndMat->size[0] = (int32_T)order;
  amcIndMat->size[1] = 16;
  emxEnsureCapacity(sp, (emxArray__common *)amcIndMat, i48, (int32_T)sizeof
                    (real_T), &m_emlrtRTEI);
  k = (int32_T)order;
  for (i48 = 0; i48 < k; i48++) {
    for (i = 0; i < 16; i++) {
      amcIndMat->data[i48 + amcIndMat->size[0] * i] = mcAdapt[((int32_T)n + 882 *
        i) - 1];
    }
  }

  emxInit_boolean_T(sp, &r3, 2, &m_emlrtRTEI, true);
  i48 = r3->size[0] * r3->size[1];
  r3->size[0] = OmegaMat->size[0];
  r3->size[1] = 16;
  emxEnsureCapacity(sp, (emxArray__common *)r3, i48, (int32_T)sizeof(boolean_T),
                    &m_emlrtRTEI);
  k = OmegaMat->size[0] * OmegaMat->size[1];
  for (i48 = 0; i48 < k; i48++) {
    r3->data[i48] = (OmegaMat->data[i48] > K);
  }

  for (i48 = 0; i48 < 2; i48++) {
    iv66[i48] = r3->size[i48];
  }

  for (i48 = 0; i48 < 2; i48++) {
    b_amcIndMat[i48] = amcIndMat->size[i48];
  }

  emxInit_boolean_T(sp, &r4, 2, &m_emlrtRTEI, true);
  if ((iv66[0] != b_amcIndMat[0]) || (iv66[1] != b_amcIndMat[1])) {
    emlrtSizeEqCheckNDR2012b(&iv66[0], &b_amcIndMat[0], &k_emlrtECI, sp);
  }

  i48 = r4->size[0] * r4->size[1];
  r4->size[0] = amcIndMat->size[0];
  r4->size[1] = 16;
  emxEnsureCapacity(sp, (emxArray__common *)r4, i48, (int32_T)sizeof(boolean_T),
                    &m_emlrtRTEI);
  k = amcIndMat->size[0] * amcIndMat->size[1];
  for (i48 = 0; i48 < k; i48++) {
    r4->data[i48] = (amcIndMat->data[i48] != 0.0);
  }

  emxFree_real_T(&amcIndMat);
  covrtLogBasicBlock(&emlrtCoverageInstance, 11U, 2);
  st.site = &te_emlrtRSI;
  for (i48 = 0; i48 < 2; i48++) {
    indexSize[i48] = r3->size[i48];
  }

  nonSingletonDimFound = false;
  if (indexSize[0] != 1) {
    nonSingletonDimFound = true;
  }

  if (nonSingletonDimFound) {
    nonSingletonDimFound = false;
  } else {
    nonSingletonDimFound = true;
  }

  if (nonSingletonDimFound) {
    b_st.site = &ue_emlrtRSI;
    c_st.site = &ve_emlrtRSI;
    emlrtErrorWithMessageIdR2012b(&c_st, &t_emlrtRTEI,
      "Coder:FE:PotentialMatrixMatrix", 0);
  }

  st.site = &te_emlrtRSI;
  for (i48 = 0; i48 < 2; i48++) {
    indexSize[i48] = r3->size[i48];
  }

  nonSingletonDimFound = false;
  if (OmegaMat->size[0] != 1) {
    nonSingletonDimFound = true;
  }

  if (nonSingletonDimFound) {
    nonSingletonDimFound = false;
  } else {
    nonSingletonDimFound = true;
  }

  if (nonSingletonDimFound) {
    b_st.site = &we_emlrtRSI;
    c_st.site = &ve_emlrtRSI;
    emlrtErrorWithMessageIdR2012b(&c_st, &t_emlrtRTEI,
      "Coder:FE:PotentialMatrixMatrix", 0);
  } else {
    nonSingletonDimFound = false;
    if (indexSize[0] != 1) {
      nonSingletonDimFound = true;
    }

    if (nonSingletonDimFound) {
      nonSingletonDimFound = false;
    } else {
      nonSingletonDimFound = true;
    }

    if (nonSingletonDimFound) {
      b_st.site = &ue_emlrtRSI;
      c_st.site = &ve_emlrtRSI;
      emlrtErrorWithMessageIdR2012b(&c_st, &t_emlrtRTEI,
        "Coder:FE:PotentialMatrixMatrix", 0);
    }
  }

  xoffset = r3->size[0] << 4;
  for (i = 0; i < xoffset; i++) {
    if (r3->data[i] && r4->data[i] && (!((i + 1 >= 1) && (i + 1 <= 320)))) {
      emlrtDynamicBoundsCheckR2012b(i + 1, 1, 320, &u_emlrtBCI, sp);
    }
  }

  emxInit_int32_T(sp, &r5, 1, &m_emlrtRTEI, true);
  xoffset = (r3->size[0] << 4) - 1;
  k = 0;
  for (i = 0; i <= xoffset; i++) {
    if (r3->data[i] && r4->data[i]) {
      k++;
    }
  }

  i48 = r5->size[0];
  r5->size[0] = k;
  emxEnsureCapacity(sp, (emxArray__common *)r5, i48, (int32_T)sizeof(int32_T),
                    &m_emlrtRTEI);
  k = 0;
  for (i = 0; i <= xoffset; i++) {
    if (r3->data[i] && r4->data[i]) {
      r5->data[k] = i + 1;
      k++;
    }
  }

  xoffset = OmegaMat->size[0] << 4;
  k = r5->size[0];
  for (i48 = 0; i48 < k; i48++) {
    i = r5->data[i48];
    if (!((i >= 1) && (i <= xoffset))) {
      emlrtDynamicBoundsCheckR2012b(i, 1, xoffset, &v_emlrtBCI, sp);
    }
  }

  emxInit_real_T2(sp, &x, 1, &m_emlrtRTEI, true);
  i48 = x->size[0];
  x->size[0] = r5->size[0];
  emxEnsureCapacity(sp, (emxArray__common *)x, i48, (int32_T)sizeof(real_T),
                    &m_emlrtRTEI);
  k = r5->size[0];
  for (i48 = 0; i48 < k; i48++) {
    x->data[i48] = K / OmegaMat->data[r5->data[i48] - 1];
  }

  emxFree_int32_T(&r5);
  emxFree_real_T(&OmegaMat);
  st.site = &te_emlrtRSI;
  nonSingletonDimFound = false;
  for (k = 0; k < x->size[0]; k++) {
    if (nonSingletonDimFound || (x->data[k] < 0.0)) {
      nonSingletonDimFound = true;
    } else {
      nonSingletonDimFound = false;
    }
  }

  if (nonSingletonDimFound) {
    b_st.site = &ac_emlrtRSI;
    w_error(&b_st);
  }

  emxInit_real_T2(&st, &r6, 1, &m_emlrtRTEI, true);
  b_st.site = &xe_emlrtRSI;
  i48 = r6->size[0];
  r6->size[0] = x->size[0];
  emxEnsureCapacity(&b_st, (emxArray__common *)r6, i48, (int32_T)sizeof(real_T),
                    &m_emlrtRTEI);
  k = x->size[0];
  for (i48 = 0; i48 < k; i48++) {
    r6->data[i48] = x->data[i48];
  }

  c_st.site = &ye_emlrtRSI;
  nonSingletonDimFound = ((!(1 > x->size[0])) && (x->size[0] > 2147483646));
  if (nonSingletonDimFound) {
    d_st.site = &kb_emlrtRSI;
    check_forloop_overflow_error(&d_st);
  }

  for (k = 0; k + 1 <= x->size[0]; k++) {
    r6->data[k] = muDoubleScalarSqrt(r6->data[k]);
  }

  emxFree_real_T(&x);
  xoffset = r3->size[0] << 4;
  k = 0;
  for (i = 0; i < xoffset; i++) {
    if (r3->data[i] && r4->data[i]) {
      k++;
    }
  }

  i48 = r6->size[0];
  if (k != i48) {
    emlrtSizeEqCheck1DR2012b(k, i48, &l_emlrtECI, sp);
  }

  xoffset = (r3->size[0] << 4) - 1;
  k = 0;
  for (i = 0; i <= xoffset; i++) {
    if (r3->data[i] && r4->data[i]) {
      k++;
    }
  }

  emxInit_real_T2(sp, &r7, 1, &m_emlrtRTEI, true);
  i48 = r7->size[0];
  r7->size[0] = k;
  emxEnsureCapacity(sp, (emxArray__common *)r7, i48, (int32_T)sizeof(real_T),
                    &m_emlrtRTEI);
  k = 0;
  for (i = 0; i <= xoffset; i++) {
    if (r3->data[i] && r4->data[i]) {
      r7->data[k] = w[i] * r6->data[k];
      k++;
    }
  }

  emxFree_real_T(&r6);
  xoffset = r3->size[0] << 4;
  k = 0;
  for (i = 0; i < xoffset; i++) {
    if (r3->data[i] && r4->data[i]) {
      k++;
    }
  }

  i48 = r7->size[0];
  if (k != i48) {
    emlrtSizeEqCheck1DR2012b(k, i48, &m_emlrtECI, sp);
  }

  xoffset = r3->size[0] << 4;
  k = 0;
  for (i = 0; i < xoffset; i++) {
    if (r3->data[i] && r4->data[i]) {
      if (!((i + 1 >= 1) && (i + 1 <= 320))) {
        emlrtDynamicBoundsCheckR2012b(i + 1, 1, 320, &w_emlrtBCI, sp);
      }

      w[i] = r7->data[k];
      k++;
    }
  }

  emxFree_boolean_T(&r4);
  emxFree_real_T(&r7);
  emxFree_boolean_T(&r3);
  covrtLogBasicBlock(&emlrtCoverageInstance, 11U, 3);
  emlrtHeapReferenceStackLeaveFcnR2012b(sp);
}

/* End of code generation (NCAF.c) */
