/*
 * diag.c
 *
 * Code generation for function 'diag'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "diag.h"
#include "blas.h"

/* Function Definitions */
void diag(const real_T v_data[], const int32_T v_size[2], real_T d_data[],
          int32_T d_size[2])
{
  int32_T j;
  int32_T i33;
  d_size[0] = (int8_T)v_size[1];
  d_size[1] = (int8_T)v_size[1];
  j = (int8_T)v_size[1] * (int8_T)v_size[1];
  for (i33 = 0; i33 < j; i33++) {
    d_data[i33] = 0.0;
  }

  for (j = 0; j + 1 <= v_size[1]; j++) {
    d_data[j + d_size[0] * j] = v_data[j];
  }
}

/* End of code generation (diag.c) */
