/*
 * gjbf.h
 *
 * Code generation for function 'gjbf'
 *
 */

#ifndef GJBF_H
#define GJBF_H

/* Include files */
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mwmathutil.h"
#include "tmwtypes.h"
#include "mex.h"
#include "emlrt.h"
#include "covrt.h"
#include "rtwtypes.h"
#include "gjbf_types.h"

/* Function Declarations */
extern void gjbf(gjbfStackData *SD, const emlrtStack *sp, const real_T x[14112],
                 real_T fs, const real_T spos[3], const real_T mpos[48], real_T
                 c, real_T p, real_T q, real_T mu, real_T order, real_T beta,
                 const real_T phi[320], const real_T psi[320], real_T K, const
                 emxArray_real_T *xPrev, const real_T bp_data[], const int32_T
                 bp_size[1], const emxArray_real_T *zp, const real_T bw1[320],
                 const real_T mw1[320], real_T snrThresh, real_T snrRate, const
                 real_T snr1[16], real_T iw, real_T y_data[], int32_T y_size[1],
                 emxArray_real_T *bmw, emxArray_real_T *mcWall, real_T snrAll
                 [14112], real_T b_data[], int32_T b_size[1], real_T z[14112],
                 real_T mcAdapt[14112]);

#endif

/* End of code generation (gjbf.h) */
