/*
 * _coder_gjbf_mex.c
 *
 * Code generation for function '_coder_gjbf_mex'
 *
 */

/* Include files */
#include "gjbf.h"
#include "_coder_gjbf_mex.h"
#include "gjbf_terminate.h"
#include "_coder_gjbf_api.h"
#include "gjbf_initialize.h"
#include "gjbf_data.h"
#include "blas.h"

/* Variable Definitions */
static gjbfStackData *gjbfStackDataGlobal = NULL;

/* Function Declarations */
static void gjbf_mexFunction(gjbfStackData *SD, int32_T nlhs, mxArray *plhs[7],
  int32_T nrhs, const mxArray *prhs[24]);

/* Function Definitions */
static void gjbf_mexFunction(gjbfStackData *SD, int32_T nlhs, mxArray *plhs[7],
  int32_T nrhs, const mxArray *prhs[24])
{
  int32_T n;
  const mxArray *inputs[24];
  const mxArray *outputs[7];
  int32_T b_nlhs;
  emlrtStack st = { NULL, NULL, NULL };

  st.tls = emlrtRootTLSGlobal;

  /* Check for proper number of arguments. */
  if (nrhs != 24) {
    emlrtErrMsgIdAndTxt(&st, "EMLRT:runTime:WrongNumberOfInputs", 5, 12, 24, 4,
                        4, "gjbf");
  }

  if (nlhs > 7) {
    emlrtErrMsgIdAndTxt(&st, "EMLRT:runTime:TooManyOutputArguments", 3, 4, 4,
                        "gjbf");
  }

  /* Temporary copy for mex inputs. */
  for (n = 0; n < nrhs; n++) {
    inputs[n] = prhs[n];
    if (*emlrtBreakCheckR2012bFlagVar != 0) {
      emlrtBreakCheckR2012b(&st);
    }
  }

  /* Call the function. */
  gjbf_api(SD, inputs, outputs);

  /* Copy over outputs to the caller. */
  if (nlhs < 1) {
    b_nlhs = 1;
  } else {
    b_nlhs = nlhs;
  }

  emlrtReturnArrays(b_nlhs, plhs, outputs);

  /* Module termination. */
  gjbf_terminate();
}

void mexFunction(int32_T nlhs, mxArray *plhs[], int32_T nrhs, const mxArray
                 *prhs[])
{
  gjbfStackDataGlobal = (gjbfStackData *)mxCalloc(1, 1U * sizeof(gjbfStackData));
  mexAtExit(gjbf_atexit);

  /* Initialize the memory manager. */
  /* Module initialization. */
  gjbf_initialize();

  /* Dispatch the entry-point. */
  gjbf_mexFunction(gjbfStackDataGlobal, nlhs, plhs, nrhs, prhs);
  mxFree(gjbfStackDataGlobal);
}

emlrtCTX mexFunctionCreateRootTLS(void)
{
  emlrtCreateRootTLS(&emlrtRootTLSGlobal, &emlrtContextGlobal, NULL, 1);
  return emlrtRootTLSGlobal;
}

/* End of code generation (_coder_gjbf_mex.c) */
