/*
 * optwbm.c
 *
 * Code generation for function 'optwbm'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "optwbm.h"
#include "diag.h"
#include "norm.h"
#include "mpower.h"
#include "gjbf_emxutil.h"
#include "gjbf_data.h"
#include "blas.h"

/* Variable Definitions */
static emlrtRSInfo nd_emlrtRSI = { 11, "optwbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\optwbm.m" };

static emlrtRSInfo od_emlrtRSI = { 10, "optwbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\optwbm.m" };

static emlrtRSInfo pd_emlrtRSI = { 12, "optwbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\optwbm.m" };

static emlrtRTEInfo h_emlrtRTEI = { 1, 15, "optwbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\optwbm.m" };

static emlrtECInfo e_emlrtECI = { -1, 10, 5, "optwbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\optwbm.m" };

static emlrtECInfo f_emlrtECI = { 2, 10, 20, "optwbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\optwbm.m" };

/* Function Definitions */
void optwbm(const emlrtStack *sp, const real_T bWin_data[], const int32_T
            bWin_size[1], real_T n, real_T w[320], const real_T z[14112], real_T
            beta, real_T mu, const boolean_T amcInds[16])
{
  int32_T idx;
  int32_T ii;
  boolean_T exitg1;
  boolean_T guard1 = false;
  int32_T loop_ub;
  int32_T ii_size_idx_1;
  int8_T tmp_data[16];
  int32_T trueCount;
  int32_T tmp_size[2];
  int32_T i41;
  int32_T i42;
  int32_T b_trueCount;
  real_T b_tmp_data[320];
  real_T z_data[16];
  int32_T z_size[2];
  emxArray_real_T *y;
  real_T b_data[256];
  int32_T b_size[2];
  real_T b_y;
  emxArray_real_T *a;
  emxArray_real_T *c_y;
  int16_T unnamed_idx_0;
  real_T alpha1;
  real_T beta1;
  char_T TRANSB;
  char_T TRANSA;
  ptrdiff_t m_t;
  ptrdiff_t n_t;
  ptrdiff_t k_t;
  ptrdiff_t lda_t;
  ptrdiff_t ldb_t;
  int32_T iv58[2];
  ptrdiff_t ldc_t;
  int32_T d_y[2];
  int32_T iv59[2];
  emlrtStack st;
  emlrtStack b_st;
  st.prev = sp;
  st.tls = sp->tls;
  b_st.prev = &st;
  b_st.tls = st.tls;
  emlrtHeapReferenceStackEnterFcnR2012b(sp);
  covrtLogFcn(&emlrtCoverageInstance, 6U, 0);

  /*  adapt everyone under no threshold */
  covrtLogIf(&emlrtCoverageInstance, 6U, 0U, 0, false);
  covrtLogBasicBlock(&emlrtCoverageInstance, 6U, 1);
  idx = 0;
  ii = 1;
  exitg1 = false;
  while ((!exitg1) && (ii < 17)) {
    guard1 = false;
    if (amcInds[ii - 1]) {
      idx++;
      if (idx >= 16) {
        exitg1 = true;
      } else {
        guard1 = true;
      }
    } else {
      guard1 = true;
    }

    if (guard1) {
      ii++;
    }
  }

  if (1 > idx) {
    loop_ub = 0;
  } else {
    loop_ub = idx;
  }

  if (1 > idx) {
    ii_size_idx_1 = 0;
  } else {
    ii_size_idx_1 = idx;
  }

  trueCount = 0;
  for (ii = 0; ii < 16; ii++) {
    if (amcInds[ii]) {
      trueCount++;
    }
  }

  idx = 0;
  for (ii = 0; ii < 16; ii++) {
    if (amcInds[ii]) {
      tmp_data[idx] = (int8_T)(ii + 1);
      idx++;
    }
  }

  tmp_size[0] = 20;
  tmp_size[1] = trueCount;
  for (i41 = 0; i41 < trueCount; i41++) {
    for (i42 = 0; i42 < 20; i42++) {
      b_tmp_data[i42 + 20 * i41] = beta * w[i42 + 20 * (tmp_data[i41] - 1)];
    }
  }

  b_trueCount = 0;
  for (ii = 0; ii < 16; ii++) {
    if (amcInds[ii]) {
      b_trueCount++;
    }
  }

  idx = 0;
  for (ii = 0; ii < 16; ii++) {
    if (amcInds[ii]) {
      tmp_data[idx] = (int8_T)(ii + 1);
      idx++;
    }
  }

  z_size[0] = 1;
  z_size[1] = b_trueCount;
  for (i41 = 0; i41 < b_trueCount; i41++) {
    z_data[i41] = z[((int32_T)n + 882 * (tmp_data[i41] - 1)) - 1];
  }

  emxInit_real_T(sp, &y, 2, &h_emlrtRTEI, true);
  st.site = &nd_emlrtRSI;
  diag(z_data, z_size, b_data, b_size);
  st.site = &pd_emlrtRSI;
  b_y = norm(bWin_data, bWin_size);
  i41 = y->size[0] * y->size[1];
  y->size[0] = bWin_size[0];
  y->size[1] = loop_ub;
  emxEnsureCapacity(sp, (emxArray__common *)y, i41, (int32_T)sizeof(real_T),
                    &h_emlrtRTEI);
  b_trueCount = bWin_size[0];
  for (i41 = 0; i41 < b_trueCount; i41++) {
    for (i42 = 0; i42 < ii_size_idx_1; i42++) {
      y->data[i41 + y->size[0] * i42] = mu * bWin_data[i41];
    }
  }

  emxInit_real_T(sp, &a, 2, &h_emlrtRTEI, true);
  st.site = &od_emlrtRSI;
  i41 = a->size[0] * a->size[1];
  a->size[0] = bWin_size[0];
  a->size[1] = loop_ub;
  emxEnsureCapacity(&st, (emxArray__common *)a, i41, (int32_T)sizeof(real_T),
                    &h_emlrtRTEI);
  b_trueCount = bWin_size[0];
  for (i41 = 0; i41 < b_trueCount; i41++) {
    for (i42 = 0; i42 < loop_ub; i42++) {
      a->data[i41 + a->size[0] * i42] = mu * bWin_data[i41];
    }
  }

  b_st.site = &bd_emlrtRSI;
  if (!(a->size[1] == b_size[0])) {
    if (((a->size[0] == 1) && (a->size[1] == 1)) || ((b_size[0] == 1) &&
         (b_size[1] == 1))) {
      emlrtErrorWithMessageIdR2012b(&b_st, &x_emlrtRTEI,
        "Coder:toolbox:mtimes_noDynamicScalarExpansion", 0);
    } else {
      emlrtErrorWithMessageIdR2012b(&b_st, &y_emlrtRTEI, "Coder:MATLAB:innerdim",
        0);
    }
  }

  emxInit_real_T(&st, &c_y, 2, &h_emlrtRTEI, true);
  if ((y->size[1] == 1) || (b_size[0] == 1)) {
    i41 = c_y->size[0] * c_y->size[1];
    c_y->size[0] = y->size[0];
    c_y->size[1] = b_size[1];
    emxEnsureCapacity(&st, (emxArray__common *)c_y, i41, (int32_T)sizeof(real_T),
                      &h_emlrtRTEI);
    loop_ub = y->size[0];
    for (i41 = 0; i41 < loop_ub; i41++) {
      b_trueCount = b_size[1];
      for (i42 = 0; i42 < b_trueCount; i42++) {
        c_y->data[i41 + c_y->size[0] * i42] = 0.0;
        ii = y->size[1];
        for (idx = 0; idx < ii; idx++) {
          c_y->data[i41 + c_y->size[0] * i42] += y->data[i41 + y->size[0] * idx]
            * b_data[idx + b_size[0] * i42];
        }
      }
    }
  } else {
    unnamed_idx_0 = (int16_T)y->size[0];
    i41 = c_y->size[0] * c_y->size[1];
    c_y->size[0] = unnamed_idx_0;
    c_y->size[1] = (int16_T)b_size[1];
    emxEnsureCapacity(&st, (emxArray__common *)c_y, i41, (int32_T)sizeof(real_T),
                      &h_emlrtRTEI);
    loop_ub = c_y->size[1];
    for (i41 = 0; i41 < loop_ub; i41++) {
      b_trueCount = c_y->size[0];
      for (i42 = 0; i42 < b_trueCount; i42++) {
        c_y->data[i42 + c_y->size[0] * i41] = 0.0;
      }
    }

    b_st.site = &ad_emlrtRSI;
    if ((a->size[0] < 1) || (b_size[1] < 1) || (a->size[1] < 1)) {
    } else {
      alpha1 = 1.0;
      beta1 = 0.0;
      TRANSB = 'N';
      TRANSA = 'N';
      m_t = (ptrdiff_t)a->size[0];
      n_t = (ptrdiff_t)b_size[1];
      k_t = (ptrdiff_t)a->size[1];
      lda_t = (ptrdiff_t)a->size[0];
      ldb_t = (ptrdiff_t)a->size[1];
      ldc_t = (ptrdiff_t)a->size[0];
      dgemm(&TRANSA, &TRANSB, &m_t, &n_t, &k_t, &alpha1, &a->data[0], &lda_t,
            &b_data[0], &ldb_t, &beta1, &c_y->data[0], &ldc_t);
    }
  }

  emxFree_real_T(&a);
  emxFree_real_T(&y);
  st.site = &pd_emlrtRSI;
  b_y = mpower(b_y);
  i41 = c_y->size[0] * c_y->size[1];
  emxEnsureCapacity(sp, (emxArray__common *)c_y, i41, (int32_T)sizeof(real_T),
                    &h_emlrtRTEI);
  ii = c_y->size[0];
  idx = c_y->size[1];
  loop_ub = ii * idx;
  for (i41 = 0; i41 < loop_ub; i41++) {
    c_y->data[i41] /= b_y;
  }

  for (i41 = 0; i41 < 2; i41++) {
    iv58[i41] = tmp_size[i41];
  }

  for (i41 = 0; i41 < 2; i41++) {
    d_y[i41] = c_y->size[i41];
  }

  if ((iv58[0] != d_y[0]) || (iv58[1] != d_y[1])) {
    emlrtSizeEqCheckNDR2012b(&iv58[0], &d_y[0], &f_emlrtECI, sp);
  }

  b_trueCount = 0;
  for (ii = 0; ii < 16; ii++) {
    if (amcInds[ii]) {
      b_trueCount++;
    }
  }

  iv59[0] = 20;
  iv59[1] = b_trueCount;
  emlrtSubAssignSizeCheckR2012b(iv59, 2, tmp_size, 2, &e_emlrtECI, sp);
  idx = 0;
  for (ii = 0; ii < 16; ii++) {
    if (amcInds[ii]) {
      tmp_data[idx] = (int8_T)(ii + 1);
      idx++;
    }
  }

  for (i41 = 0; i41 < trueCount; i41++) {
    for (i42 = 0; i42 < 20; i42++) {
      w[i42 + 20 * (tmp_data[i41] - 1)] = b_tmp_data[i42 + 20 * i41] + c_y->
        data[i42 + c_y->size[0] * i41];
    }
  }

  emxFree_real_T(&c_y);
  covrtLogBasicBlock(&emlrtCoverageInstance, 6U, 2);
  emlrtHeapReferenceStackLeaveFcnR2012b(sp);
}

/* End of code generation (optwbm.c) */
