/*
 * targbm.c
 *
 * Code generation for function 'targbm'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "gjbf.h"
#include "targbm.h"
#include "mclms.h"
#include "indexShapeCheck.h"
#include "gjbf_mexutil.h"
#include "gjbf_data.h"
#include "blas.h"

/* Variable Definitions */
static emlrtRSInfo vc_emlrtRSI = { 15, "targbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\targbm.m" };

static emlrtRSInfo wc_emlrtRSI = { 12, "targbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\targbm.m" };

static emlrtRSInfo xc_emlrtRSI = { 5, "targbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\targbm.m" };

static emlrtBCInfo h_emlrtBCI = { -1, -1, 5, 17, "bp", "targbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\targbm.m", 0 };

static emlrtBCInfo i_emlrtBCI = { 1, 882, 7, 18, "b", "targbm",
  "E:\\micro array project\\Microphone Array\\beamform test\\targbm.m", 0 };

/* Function Definitions */
void targbm(const emlrtStack *sp, const real_T bp_data[], const int32_T bp_size
            [1], const real_T b[882], const real_T x[14112], real_T n, real_T
            order, const real_T w[320], real_T z[14112], real_T bWin_data[],
            int32_T bWin_size[1])
{
  real_T d2;
  int32_T k;
  int32_T i35;
  int32_T iv56[2];
  int32_T loop_ub;
  int32_T i36;
  real_T a[320];
  real_T y[16];
  boolean_T bv19[16];
  boolean_T bv20[16];
  boolean_T b_y;
  boolean_T exitg1;
  const mxArray *c_y;
  char_T u[19];
  static const char_T varargin_1[19] = { 'O', 'u', 't', 'p', 'u', 't', ' ', 'h',
    'a', 's', ' ', 'b', 'l', 'o', 'w', 'n', ' ', 'u', 'p' };

  const mxArray *m28;
  static const int32_T iv57[2] = { 1, 19 };

  emlrtStack st;
  emlrtStack b_st;
  st.prev = sp;
  st.tls = sp->tls;
  b_st.prev = &st;
  b_st.tls = st.tls;
  covrtLogFcn(&emlrtCoverageInstance, 4U, 0);

  /*  Select the data window (column vector) and ouput adapf   */
  if (covrtLogIf(&emlrtCoverageInstance, 4U, 0U, 0, n <= order)) {
    covrtLogBasicBlock(&emlrtCoverageInstance, 4U, 0);

    /*  feed in supplied past values ahead of b */
    d2 = (((real_T)bp_size[0] - order) + n) + 1.0;
    if (d2 > bp_size[0]) {
      k = 1;
      i35 = 1;
    } else {
      k = (int32_T)d2;
      if (!((k >= 1) && (k <= bp_size[0]))) {
        emlrtDynamicBoundsCheckR2012b(k, 1, bp_size[0], &h_emlrtBCI, sp);
      }

      if (!(bp_size[0] >= 1)) {
        emlrtDynamicBoundsCheckR2012b(bp_size[0], 1, bp_size[0], &h_emlrtBCI, sp);
      }

      i35 = bp_size[0] + 1;
    }

    iv56[0] = 1;
    iv56[1] = i35 - k;
    st.site = &xc_emlrtRSI;
    indexShapeCheck(&st, bp_size[0], iv56);
    bWin_size[0] = (i35 - k) + (int32_T)n;
    loop_ub = i35 - k;
    for (i36 = 0; i36 < loop_ub; i36++) {
      bWin_data[i36] = bp_data[(k + i36) - 1];
    }

    loop_ub = (int32_T)n;
    for (i36 = 0; i36 < loop_ub; i36++) {
      bWin_data[(i36 + i35) - k] = b[i36];
    }
  } else {
    covrtLogBasicBlock(&emlrtCoverageInstance, 4U, 1);

    /*  need only data from given b */
    d2 = (n - order) + 1.0;
    if (d2 > n) {
      k = 0;
      i35 = 0;
    } else {
      k = (int32_T)d2;
      if (!((k >= 1) && (k <= 882))) {
        emlrtDynamicBoundsCheckR2012b(k, 1, 882, &i_emlrtBCI, sp);
      }

      k--;
      i35 = (int32_T)n;
    }

    bWin_size[0] = i35 - k;
    loop_ub = i35 - k;
    for (i35 = 0; i35 < loop_ub; i35++) {
      bWin_data[i35] = b[k + i35];
    }
  }

  covrtLogBasicBlock(&emlrtCoverageInstance, 4U, 2);

  /*  initial w ,and calculate output y       */
  st.site = &wc_emlrtRSI;
  for (k = 0; k < 20; k++) {
    for (i35 = 0; i35 < 16; i35++) {
      a[i35 + (k << 4)] = w[k + 20 * i35];
    }
  }

  b_st.site = &bd_emlrtRSI;
  if (!(20 == bWin_size[0])) {
    if (bWin_size[0] == 1) {
      emlrtErrorWithMessageIdR2012b(&b_st, &x_emlrtRTEI,
        "Coder:toolbox:mtimes_noDynamicScalarExpansion", 0);
    } else {
      emlrtErrorWithMessageIdR2012b(&b_st, &y_emlrtRTEI, "Coder:MATLAB:innerdim",
        0);
    }
  }

  b_st.site = &ad_emlrtRSI;
  for (k = 0; k < 16; k++) {
    y[k] = 0.0;
    for (i35 = 0; i35 < 20; i35++) {
      y[k] += a[k + (i35 << 4)] * bWin_data[i35];
    }
  }

  /*  Subtract filtered b */
  /*  check y inf or not */
  for (k = 0; k < 16; k++) {
    z[((int32_T)n + 882 * k) - 1] = x[((int32_T)n + 882 * k) - 1] - y[k];
    bv19[k] = !muDoubleScalarIsInf(z[((int32_T)n + 882 * k) - 1]);
    bv20[k] = !muDoubleScalarIsNaN(z[((int32_T)n + 882 * k) - 1]);
  }

  b_y = false;
  k = 0;
  exitg1 = false;
  while ((!exitg1) && (k < 16)) {
    if (!!!(bv19[k] && bv20[k])) {
      b_y = true;
      exitg1 = true;
    } else {
      k++;
    }
  }

  if (covrtLogIf(&emlrtCoverageInstance, 4U, 0U, 1, b_y)) {
    st.site = &vc_emlrtRSI;
    for (k = 0; k < 19; k++) {
      u[k] = varargin_1[k];
    }

    c_y = NULL;
    m28 = emlrtCreateCharArray(2, iv57);
    emlrtInitCharArrayR2013a(&st, 19, m28, &u[0]);
    emlrtAssign(&c_y, m28);
    b_st.site = &af_emlrtRSI;
    ab_error(&b_st, c_y, &emlrtMCI);
  }

  covrtLogBasicBlock(&emlrtCoverageInstance, 4U, 3);
}

/* End of code generation (targbm.c) */
