/*
 * _coder_wind_api.c
 *
 * Code generation for function '_coder_wind_api'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "wind.h"
#include "_coder_wind_api.h"
#include "wind_emxutil.h"
#include "wind_data.h"

/* Variable Definitions */
static emlrtRTEInfo b_emlrtRTEI = { 1, 1, "_coder_wind_api", "" };

/* Function Declarations */
static real_T b_emlrt_marshallIn(const emlrtStack *sp, const mxArray *u, const
  emlrtMsgIdentifier *parentId);
static const mxArray *b_emlrt_marshallOut(const emxArray_real_T *u);
static real_T c_emlrt_marshallIn(const emlrtStack *sp, const mxArray *src, const
  emlrtMsgIdentifier *msgId);
static real_T emlrt_marshallIn(const emlrtStack *sp, const mxArray *tWin, const
  char_T *identifier);
static const mxArray *emlrt_marshallOut(const real_T u);

/* Function Definitions */
static real_T b_emlrt_marshallIn(const emlrtStack *sp, const mxArray *u, const
  emlrtMsgIdentifier *parentId)
{
  real_T y;
  y = c_emlrt_marshallIn(sp, emlrtAlias(u), parentId);
  emlrtDestroyArray(&u);
  return y;
}

static const mxArray *b_emlrt_marshallOut(const emxArray_real_T *u)
{
  const mxArray *y;
  const mxArray *m1;
  static const int32_T iv0[2] = { 0, 0 };

  y = NULL;
  m1 = emlrtCreateNumericArray(2, iv0, mxDOUBLE_CLASS, mxREAL);
  mxSetData((mxArray *)m1, (void *)u->data);
  emlrtSetDimensions((mxArray *)m1, u->size, 2);
  emlrtAssign(&y, m1);
  return y;
}

static real_T c_emlrt_marshallIn(const emlrtStack *sp, const mxArray *src, const
  emlrtMsgIdentifier *msgId)
{
  real_T ret;
  static const int32_T dims = 0;
  emlrtCheckBuiltInR2012b(sp, msgId, src, "double", false, 0U, &dims);
  ret = *(real_T *)mxGetData(src);
  emlrtDestroyArray(&src);
  return ret;
}

static real_T emlrt_marshallIn(const emlrtStack *sp, const mxArray *tWin, const
  char_T *identifier)
{
  real_T y;
  emlrtMsgIdentifier thisId;
  thisId.fIdentifier = identifier;
  thisId.fParent = NULL;
  thisId.bParentIsCell = false;
  y = b_emlrt_marshallIn(sp, emlrtAlias(tWin), &thisId);
  emlrtDestroyArray(&tWin);
  return y;
}

static const mxArray *emlrt_marshallOut(const real_T u)
{
  const mxArray *y;
  const mxArray *m0;
  y = NULL;
  m0 = emlrtCreateDoubleScalar(u);
  emlrtAssign(&y, m0);
  return y;
}

void wind_api(const mxArray * const prhs[3], const mxArray *plhs[3])
{
  emxArray_real_T *inx;
  real_T tWin;
  real_T fs;
  real_T nmic;
  real_T nWin;
  real_T nInc;
  emlrtStack st = { NULL, NULL, NULL };

  st.tls = emlrtRootTLSGlobal;
  emlrtHeapReferenceStackEnterFcnR2012b(&st);
  emxInit_real_T(&st, &inx, 2, &b_emlrtRTEI, true);

  /* Marshall function inputs */
  tWin = emlrt_marshallIn(&st, emlrtAliasP(prhs[0]), "tWin");
  fs = emlrt_marshallIn(&st, emlrtAliasP(prhs[1]), "fs");
  nmic = emlrt_marshallIn(&st, emlrtAliasP(prhs[2]), "nmic");

  /* Invoke the target function */
  wind(&st, tWin, fs, nmic, &nWin, &nInc, inx);

  /* Marshall function outputs */
  plhs[0] = emlrt_marshallOut(nWin);
  plhs[1] = emlrt_marshallOut(nInc);
  plhs[2] = b_emlrt_marshallOut(inx);
  inx->canFreeData = false;
  emxFree_real_T(&inx);
  emlrtHeapReferenceStackLeaveFcnR2012b(&st);
}

/* End of code generation (_coder_wind_api.c) */
